<?php
/***************************************************************************\
*
*	Copyright (c) 2013 deltra Business Software GmbH & Co. KG
*	http://www.deltra.de
*	Zuletzt bearbeitet am: 2013-03-05
*
\***************************************************************************/

$GLOBALS['VERSION_SCF'] = "4.0.00";

$GLOBALS['tax_values_shopware'] = '';	// wird in den jeweiligen Funktionen gefllt
	
/**
 * @abstract    Die Funktion starten() wird bei diesem Interface (Shopware)
 *              nicht genutzt.
 */
function starten()
{
	// dummy
}

/**
 * @abstract    Die Funktion ende() wird bei diesem Interface (Shopware)
 *              nicht genutzt.
 */
function ende()
{
	// dummy
}

/**
 * @abstract	prft ob der Steuersatz eines Artikels mit einem Steuersatz aus
 *				Shopware bereinstimmt, falls ja wird dessen ID zurckgegeben
 * @param		integer $tax_value Der zu berprfende Wert
 * @return		integer
 */
function getTaxID($tax_value)
{
	$tax_values = $GLOBALS['tax_values_shopware'];
	foreach ($tax_values as $id => $tax)
	{
		if($tax == $tax_value)
		{
			return $id;
		}
	}
	
	return 0;
}

/**
 * @abstract    Pr?ft einen String auf UTF-8-Kompatibilit?t.
 * @param       string $str Der zu ?berpr?fende String.
 * @return      boolean
 */
function is_utf8($str)
{
    return preg_match("/^(
         [\x09\x0A\x0D\x20-\x7E]            # ASCII
       | [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
       |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
       | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
       |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
       |  \xF0[\x90-\xBF][\x80-\xBF]{2}     # planes 1-3
       | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
       |  \xF4[\x80-\x8F][\x80-\xBF]{2}     # plane 16
      )*$/x",
      $str);
}

/**
 * @abstract    Konditionierte Konvertierung eines Strings nach utf-8.
 * @param       string $str         Der zu kodierender String
 * @param       string $inputEnc    Vermutete Kodierung des Strings
 * @return      string
 */
function make_utf8($str, $inputEnc='WINDOWS-1252')
{
    if ( is_utf8($str) )
    {
        // Nichts zu tun.
        return $str;
    }

    if ( strtoupper($inputEnc) == 'ISO-8859-1')
    {
        return utf8_encode($str);
    }

    if ( function_exists('mb_convert_encoding') )
    {
        return mb_convert_encoding($str, 'UTF-8', $inputEnc);
    }

    if ( function_exists('iconv') )
    {
        return iconv($inputEnc, 'UTF-8', $str);
    }

    else
    {
        // Wahlweise R?ckgabe des Originalstrings,
        return($str);
        // oder Fehlerausgang.
        /*
        die(xml_error_ausgeben("make_utf8: Der String konnte nicht konvertiert werden!", __FILE__, __FUNCTION__, __LINE__));
        */
    }
}


/** Start-Funktion Daten?bertragung Shopware -> orgaMax */
function daten_holen() {
 
	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet
	// datakind == 3 => Daten werden als XMLDoc durchgereicht

	$GLOBALS['datakind'] = "3";

    try {

        /*
            Klassen laden, Aliase erstellen und Einstellungen vornehmen
        */

        /*
         * ACHTUNG: Bse Falle!
         * orgamax_osc.php inkludiert shopware.php. Aus diesem Grunde
         * ist die Referenz auf die api.php relativ von orgamax_osc.php
         * anzugeben.
        */
        require_once('../api/api.php'); 
        $api = new sAPI();

        /*
            Absicherung des API-Calls ?ber einen eindeutigen API - Schl?ssel
            API-Schl?ssel-Erstellung:
            Shopware.Backend > Einstellungen > Schnittstellen > API
        
        if ($_REQUEST["sAPI"]!=$api->sSystem->sCONFIG["sAPI"]){
            echo("API-Key ung?ltig!");
            exit;
        }
        */

        $export =& $api->export->shopware;
        $xml =& $api->convert->xml;
        $mapping =& $api->convert->mapping;
        $xml->sSettings['encoding'] = "utf-8";

        /*
            Bestellungen mit dem Status 0 auslesen
        */

        $orders = $export->sGetOrders (array("where"=>"status=".$GLOBALS["DEFAULT_ORDERS_STATUS"]));
        $orderIDs = array_keys($orders);
        if(!$orders)
        {
           //Keine Bestellungen, dann leere OrderNotification-Liste ausgeben,
           //damit ERP diesen Zustand erkennen kann.
           $orders = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'."\n".
                      '<OrderNotification>'."\n".
                      '</OrderNotification>'."\n";
           echo($orders);
           exit;
        }

        /*
            Die dazu passenden Kunden auslesen
        */
        $customers = $export->sOrderCustomers(array("orderIDs"=> $orderIDs));
        if(!$customers) 
        {
           //Keine Kunden zu evtl. Bestellungen (unwahrscheinlicher Fall),
           //dann leere OrderNotification-Liste ausgeben,
           //damit ERP diesen Zustand erkennen kann.
           $orders = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'."\n".
                      '<OrderNotification>'."\n".
                      '</OrderNotification>'."\n";
           echo($orders);
           exit;
        }
        /*
            Und die dazu passenden Bestellpositionen auslesen
        */
        $positions = $export->sOrderDetails(array("orderIDs"=> $orderIDs));
        if(!$positions)
        {
           //Keine Bestellpositionen zu evtl. Bestellungen (unwahrscheinlicher Fall),
           //dann leere OrderNotification-Liste ausgeben,
           //damit ERP diesen Zustand erkennen kann.
           $orders = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'."\n".
                      '<OrderNotification>'."\n".
                      '</OrderNotification>'."\n";
           echo($orders);
           exit;
        }
        /*
            Bestellung maskieren
        */
        $ordermask = array (
            "orderID",
            "ordernumber",
            "customerID",
            "paymentID",
            "transactionID",
            "partnerID",
            "clearedID",
            "statusID",
            "paymentID",
            "ordertime",
            "cleareddate",
            "cleared_date",
            "language",
            "currency",
            "currencyFactor",
            "subshopID",
            "dispatch_description",
            "currency_description",
            "invoice_amount",
            "invoice_amount_net",
            "invoice_shipping",
            "invoice_shipping_net",
            "net",
            "cleared_description",
            "status_description",
            "payment_description",
			"comment",
			"customercomment"
        );
		
        $orders = $mapping->convert_array ($ordermask, $orders);

        /*
            Kunden maskieren
        */
        $salutationmap = array(
            "mr" => "Herr",
            "ms" => "Frau",
            "_default" => ""
        );
        $customermask = array (
            "customernumber",
            "billing_company",
            "billing_department",
            "billing_salutation" => array (
                "convert" => array(
                    "map" =>  $salutationmap
                )
            ),
            "billing_firstname",
            "billing_lastname",
            "billing_street",
            "billing_streetnumber",
            "billing_street",
            "billing_zipcode",
            "billing_city",
            "billing_country",
            "billing_countryen",
            "billing_countryiso",
            "shipping_company",
            "shipping_department",
            "shipping_salutation" => array (
                "convert" => array(
                    "map" =>  $salutationmap
                )
            ),
            "shipping_firstname",
            "shipping_lastname",
            "shipping_street",
            "shipping_streetnumber",
            "shipping_street",
            "shipping_zipcode",
            "shipping_city",
            "shipping_country",
            "shipping_countryen",
            "shipping_countryiso",
            "ustid" => array (
                "convert" => "trim"
            ),
            "phone",
            "fax",
            "email",
            "customergroup",
        );
        $customers = $mapping->convert_array ($customermask, $customers);

        /*
            Bestellpositionen maskieren
        */
        $positionmask = array (
            "orderdetailsID",
            "articleID",
            "articleordernumber",
            "name",
            "price",
            "quantity",
            "invoice",
            "releasedate",
            "tax",
            "esd",
            "modus",
        );
        foreach ($positions as $orderID =>$position)
        {
            $tmp[$orderID] = $mapping->convert_array ($positionmask, $position);
        }
        $positions = $tmp;

        /*
            Alle Daten zusammenfassen
        */
        $open_orders = array();

        foreach ($orderIDs as $orderID)
        {
		    if(isset($orders[$orderID])&&$customers[$orderID]&&$positions[$orderID])
            {
				//Sql Query um Bankdaten abzurufen.
				$sql = 'SELECT * FROM s_user_debit WHERE userID = '.$orders[$orderID]['customerID'];
				$Bankdaten = $export->sDB->GetRow($sql);
			
         
                $open_orders[$orderID]['BestellnummerShop'] = $orders[$orderID]['ordernumber'];
                $open_orders[$orderID]['Bestelldatum']= $orders[$orderID]['ordertime'];

                $open_orders[$orderID]['Wunschlieferdatum']= "";
                $open_orders[$orderID]['Lieferart']= make_utf8($orders[$orderID]['dispatch_description']);
                $open_orders[$orderID]['Zahlungsart']= make_utf8($orders[$orderID]['payment_description']);
                $open_orders[$orderID]['ZusatzfeldBestellung1']= "";
                $open_orders[$orderID]['ZusatzfeldBestellung2']= "";
                $open_orders[$orderID]['ZusatzfeldBestellung3']= "";
                $open_orders[$orderID]['ZusatzfeldBestellung4']= "";
                $open_orders[$orderID]['ZusatzfeldBestellung5']= "";
				
				// Kundenkommentare importieren, falls Einstellung in config.php gesetzt
				$open_orders[$orderID]['AnmerkungenBestellung'] = ($GLOBALS['customercomment_import']) ? make_utf8($orders[$orderID]['customercomment']) : "";

                //ERP Kundendaten Kunden
                $open_orders[$orderID]['Kundendaten']['Kunde']['Kundennummer'] = make_utf8($customers[$orderID]['customerID']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['KundennummerWebshop']= make_utf8($customers[$orderID]['customernumber']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Firmenname']= make_utf8($customers[$orderID]['billing_company']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Firmenzusatzname']= make_utf8($customers[$orderID]['billing_department']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['PersonAnrede']= make_utf8($customers[$orderID]['billing_salutation']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['PersonGeschlecht']= "";
                $open_orders[$orderID]['Kundendaten']['Kunde']['PersonTitel']= "";
                $open_orders[$orderID]['Kundendaten']['Kunde']['PersonNachname']= make_utf8($customers[$orderID]['billing_lastname']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['PersonVorname']= make_utf8($customers[$orderID]['billing_firstname']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Strasse']= make_utf8($customers[$orderID]['billing_street'] . " " . $customers[$orderID]['billing_streetnumber']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Postleitzahl']= make_utf8($customers[$orderID]['billing_zipcode']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Ort']= make_utf8($customers[$orderID]['billing_city']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Laendercode']= LaenderkuerzelISO2OMX(make_utf8($customers[$orderID]['billing_countryiso']));
                $open_orders[$orderID]['Kundendaten']['Kunde']['Land']= make_utf8($customers[$orderID]['billing_country']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Email']= make_utf8($customers[$orderID]['email']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Telefon']= make_utf8($customers[$orderID]['phone']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Fax']= make_utf8($customers[$orderID]['fax']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['Umsatzsteueridentnummer']= make_utf8($customers[$orderID]['ustid']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['ZusatzfeldKunde1']= make_utf8($customers[$orderID]['customergroup']);
                $open_orders[$orderID]['Kundendaten']['Kunde']['ZusatzfeldKunde2']= "";
                $open_orders[$orderID]['Kundendaten']['Kunde']['ZusatzfeldKunde3']= "";
                $open_orders[$orderID]['Kundendaten']['Kunde']['ZusatzfeldKunde4']= "";
                $open_orders[$orderID]['Kundendaten']['Kunde']['ZusatzfeldKunde5']= "";

				//ERP Kundendaten Kontodaten
                $open_orders[$orderID]['Kundendaten']['Kontodaten']['BankkontoInhaber']= make_utf8($Bankdaten['bankholder']);
				$open_orders[$orderID]['Kundendaten']['Kontodaten']['Bankkontonummer']= make_utf8($Bankdaten['account']);
                $open_orders[$orderID]['Kundendaten']['Kontodaten']['BankkontoBLZ']= make_utf8($Bankdaten['bankcode']);
                $open_orders[$orderID]['Kundendaten']['Kontodaten']['BankkontoBankName']= make_utf8($Bankdaten['bankname']);

                //ERP Kundendaten AbweichendLieferung
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungFirmenname'] = make_utf8($customers[$orderID]['shipping_company']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungFirmenzusatz']= make_utf8($customers[$orderID]['shipping_department']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPersAnrede'] = make_utf8($customers[$orderID]['shipping_salutation']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPersGeschl']= "";
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPersTitel']= "";
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPersNachname']= make_utf8($customers[$orderID]['shipping_lastname']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPersVorname']= make_utf8($customers[$orderID]['shipping_firstname']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungStrasse']= make_utf8($customers[$orderID]['shipping_street'] . " " . $customers[$orderID]['shipping_streetnumber']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungPostleitzahl']= make_utf8($customers[$orderID]['shipping_zipcode']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungOrt']= make_utf8($customers[$orderID]['shipping_city']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungLaendercode']= LaenderkuerzelISO2OMX(make_utf8($customers[$orderID]['shipping_countryiso']));
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungLand']= make_utf8($customers[$orderID]['shipping_country']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungEmail']= make_utf8($customers[$orderID]['email']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungTelefon']= make_utf8($customers[$orderID]['phone']);
                $open_orders[$orderID]['Kundendaten']['AbweichendLieferung']['abweichendLieferungFax']= make_utf8($customers[$orderID]['fax']);

                //ERP Kundendaten AbweichendRechnung
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungFirmenname']= make_utf8($customers[$orderID]['billing_company']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungFirmenzusatz']= make_utf8($customers[$orderID]['billing_department']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPersAnrede']= make_utf8($customers[$orderID]['billing_salutation']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPersGeschl']= "";
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPersTitel']= "";
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPersNachname']= make_utf8($customers[$orderID]['billing_lastname']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPersVorname']= make_utf8($customers[$orderID]['billing_firstname']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungStrasse']= make_utf8($customers[$orderID]['billing_street']). " ". make_utf8($customers[$orderID]['billing_streetnumber']);;
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungPostleitzahl']= make_utf8($customers[$orderID]['billing_zipcode']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungOrt']= make_utf8($customers[$orderID]['billing_city']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungLaendercode']= LaenderkuerzelISO2OMX(make_utf8($customers[$orderID]['billing_countryiso']));
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungLand']= make_utf8($customers[$orderID]['billing_country']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungEmail']= "";
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungTelefon']= make_utf8($customers[$orderID]['billing_phone']);
                $open_orders[$orderID]['Kundendaten']['AbweichendRechnung']['abweichendRechnungFax']= make_utf8($customers[$orderID]['billing_fax']);

                //ERP Kundendaten Frachtkosten
                $open_orders[$orderID]['Kundendaten']['Frachtkosten']['FrachtkostenNetto']= make_utf8($orders[$orderID]['invoice_shipping_net']);
                $open_orders[$orderID]['Kundendaten']['Frachtkosten']['FrachtkostenBrutto']= make_utf8($orders[$orderID]['invoice_shipping']);
                $open_orders[$orderID]['Kundendaten']['Frachtkosten']['FrachtkostenMwStProzent']= "";

                //ERP Zuschlagskosten
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenNetto1']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenBrutto1']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenMwStProzent1']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenNetto2']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenBrutto2']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenMwStProzent2']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenNetto3']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenBrutto3']= "";
                $open_orders[$orderID]['Zuschlagskosten']['ZuschlagkostenMwStProzent3']= "";

                //ERP BestellArtikel
                $positionIDs = array_keys($positions[$orderID]);
                foreach ($positionIDs as $positionID){
                    
                    $pos = array();
      
                    $pos['Positionsnummer'] = make_utf8($positions[$orderID][$positionID]['orderdetailsID']);
                    $pos['Artikelnummer'] = make_utf8($positions[$orderID][$positionID]['articleordernumber']);
                    $pos['ArtikelnummerShop'] = make_utf8($positions[$orderID][$positionID]['articleordernumber']);
                    $pos['Menge'] = make_utf8($positions[$orderID][$positionID]['quantity']);
					
					//berprfen ob Bestellung Netto oder Brutto ist
					if ($orders[$orderID]['net']) { // Bestellung ist netto
						$pos['abweichenderEinzelpreisNetto'] = make_utf8($positions[$orderID][$positionID]['price']);
					} else {
						$pos['abweichenderEinzelpreisBrutto'] = make_utf8($positions[$orderID][$positionID]['price']);
					}
					
					// abweichendeMwStProzent eintragen, zuvor berprfen ob Feld leer ist
					if(!empty($positions[$orderID][$positionID]['tax']) && !is_null($positions[$orderID][$positionID]['tax']))
					{
						if($positions[$orderID][$positionID]['tax'] == 0)
						{
							$pos['abweichendeMwStProzent'] = "0.0";
						}
						else
						{
							$pos['abweichendeMwStProzent'] = make_utf8($positions[$orderID][$positionID]['tax']);
						}
					}
					else
					{
						$pos['abweichendeMwStProzent'] = "0.0";
					}
					
                    //$pos['abweichenderArtikeltext'] = make_utf8($positions[$orderID][$positionID]['name']);
                    $pos['RabattProzent'] = "";
                    $pos['ZusatzfeldPosition1'] = "";
                    $pos['ZusatzfeldPosition2'] = "";
                    $pos['ZusatzfeldPosition3'] = "";
                    $pos['ZusatzfeldPosition4'] = "";
                    $pos['ZusatzfeldPosition5'] = "";
                    $open_orders[$orderID]['BestellArtikel'][] = $pos;
                }
            }
        }
		

        /*
            Daten in XML konvertieren
        */
        $orders = $xml->encode(array("OrderNotification"=>array("Bestellvorgang"=>$open_orders)));
        
        if (is_null($orders))
        {
           //Konnten keinen Bestellungen ermittelt werden (hier ein unwahrscheinlicher Fall),
           //dann leere OrderNotification-Liste ausgeben,
           //damit ERP diesen Zustand erkennen kann.
           $orders = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'."\n".
                      '<OrderNotification>'."\n".
                      '</OrderNotification>'."\n";
           echo($orders);
           exit;
        }

				//Bestellsstatus neu setzen
				$export->sUpdateOrderStatus(array("orderIDs"=>$orderIDs, "status"=>$GLOBALS["aendern_zu"]));

        $GLOBALS['XMLDoc'] = $orders;
        return $GLOBALS['datakind'];


        } catch (Exception $e) {

                $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
                '<orgamax_phperror>'."\n".
                '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
                '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
                '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
                '<line>'.utf8_encode(__LINE__).'</line>'."\n".
                '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
                '</orgamax_phperror>';
                die ($catchExeption);
        }
}

function artikeldaten_shop_zu_orgamax()
{
    $GLOBALS['datakind'] = "3";

    try {

            /*
                Klassen laden, Aliase erstellen und Einstellungen vornehmen
            */

            require_once('../api/api.php');
            $api = new sAPI();
            //
            $export =& $api->export->shopware;
            $xml =& $api->convert->xml;
            $mapping =& $api->convert->mapping;
            $xml->sSettings['encoding'] = "utf-8";

            /*
                Artikel auslesen
            */
            //$articles = $export->sArticles ();    //liefert keine Details wie etwa Preise, o.?.
            $articles = $export->sFullArticles ();
            $articlesIDs = array_keys($articles);

            if(!$articles)
                exit();

          /*
            Artikel maskieren
          */
          $articlemask = array (
            "articledetailsID",
            "articleID",
            "ordernumber",
            "name",
            "description",
			"description_long", 
            "shippingtime",
            "added",
            "shippingfree",
            "releasedate",
            "topseller",
            "free",
            "keywords",
            "minpurchase",
            "purchasesteps",
            "maxpurchase",
            "purchaseunit",
            "status_description",
            "referenceunit",
            "changed",
            "suppliernumber",
            "kind",
            "additionaltext",
            "active",
            "instock",
            "stockmin",
            "esd",
            "weight",
            "position",
            "taxID",
            "supplierID",
            "unitID",
            "tax",
            "supplier",
            "unit",
            "prices" => array(
                "isset",
                "convert" => array(
                    "put_value" => "price"
                    )
             ),
            "categories" => array(
                 "isset",
                 "convert" => array(
                    "put_value" => "category"
                 )
            )
          );

        $articles = $mapping->convert_array ($articlemask, $articles);

        /*
            Alle Daten zusammenfassen
        */
        $tmp_articles = array();
        foreach ($articlesIDs as $a)
        {
            if(isset($articles[$a])&&$articles[$a]['prices']['price'][0])
            {
                //ERP Artikelimportfelder
                $tmp_articles[$a]['Artikelnummer'] = '';
                $tmp_articles[$a]['ArtikelnummerWebshop'] = make_utf8($articles[$a]['ordernumber'], 20);
                $tmp_articles[$a]['Artikelbeschreibung'] = make_utf8($articles[$a]['name'] . ' ' . $articles[$a]['additionaltext'], 250);
				$tmp_articles[$a]['MwStCode'] = make_utf8($articles[$a]['tax'], 20); 
				if($tmp_articles[$a]['MwStCode'] == '0')
				{
					$tmp_articles[$a]['MwStCode'] = '0,0';
				}
                $tmp_articles[$a]['Einheit'] = make_utf8($articles[$a]['unit'], 20);
                if (isset($articles[$a]['categories']['category'][0]))
                {
					$cats = $export->sCategories();
					foreach($cats as $cat){
						
						if($articles[$a]['categories']['category'][0] == $cat['categoryID']){
							$tmp_articles[$a]['Artikelkategorie'] = make_utf8(strip_tags($cat['description']));
						}
						
					}
                }
				
                $tmp_articles[$a]['Gewicht']= make_utf8($articles[$a]['weight']);
                $tmp_articles[$a]['Volumen']= "";
				
				// Artikelbeschreibung optimieren
				$articles[$a]['description'] = strip_tags($articles[$a]['description']);
				$articles[$a]['description'] = mb_convert_encoding($articles[$a]['description'], 'UTF-8', 'HTML-ENTITIES');
				// Artikelbeschreibung optimiert
				
                $tmp_articles[$a]['Anmerkungen'] = make_utf8($articles[$a]['description'], 250);
                $tmp_articles[$a]['ArtikelpreisNetto'] = make_utf8(str_replace(',','.',$articles[$a]['prices']['price'][0]['net_price']));
                $tmp_articles[$a]['ArtikelpreisBrutto'] = make_utf8(str_replace(',','.',$articles[$a]['prices']['price'][0]['price']));
                $tmp_articles[$a]['Einkaufspreis'] = make_utf8(str_replace(',', '.', $articles[$a]['prices']['price'][0]['baseprice']));
                $tmp_articles[$a]['Artikelbild'] = "";
                $tmp_articles[$a]['IndividuellesFeld1'] = ""; //Lnge 50
                $tmp_articles[$a]['IndividuellesFeld2'] = ""; //Lnge 50
                $tmp_articles[$a]['IndividuellesFeld3'] = ""; //Lnge 50
                $tmp_articles[$a]['IndividuellesFeld4'] = ""; //Lnge 50
                $tmp_articles[$a]['IndividuellesFeld5'] = ""; //Lnge 50
            }
        }

        /*
            Artikel-Daten in XML konvertieren
        */
        $articles = $xml->encode(array("Artikelimport"=>array("row"=>$tmp_articles)));

        /*
            Test XML-Daten ausgeben
        */
        //echo $articles;
        //exit;

        /*
            Produktion XML-Daten zur?ckgeben
        */

        $GLOBALS['XMLDoc'] = $articles;
        return $GLOBALS['datakind'];

        } catch (Exception $e) {

                $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
                '<orgamax_phperror>'."\n".
                '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
                '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
                '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
                '<line>'.utf8_encode(__LINE__).'</line>'."\n".
                '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
                '</orgamax_phperror>';
                die ($catchExeption);
        }
}

function artikeldaten_orgamax_zu_shop()
{
	require_once('../api/api.php');

	try
	{
	    $api = new sAPI();
		 
		$import = &$api->import->shopware;
		$export = &$api->export->shopware;
		
		// Tax Values ermitteln
		$settings = $export->sSettings();
		if($settings)
		{
			// Tax Values aus Settings Array lesen
			foreach($settings['tax'] as $id => $value) {
				$tax_values[$id] = $value['tax'];
			}
		}
		
		// Tax Values global verfgbar machen fr Funktion getTaxID()
		$GLOBALS['tax_values_shopware'] = $tax_values;
		
		$articleFile = file_get_contents('php://input');
		if($articleFile != null && strlen($articleFile) > 0) {
		
			$articles = simplexml_load_string(($articleFile));
			
			$amount_successfully_created = 0;
			$amount_articles = count($articles);
			
			foreach($articles as $article)
			{
				$Artikelbeschreibung = strip_tags(htmlentities($article->Artikelbeschreibung, ENT_QUOTES, 'UTF-8'));

				$Anmerkungen = html_entity_decode(htmlentities($article->Anmerkungen, ENT_QUOTES, 'UTF-8'),ENT_QUOTES, 'UTF-8');
				//Artikel in shopware speichern
				//Ermittlung der Einheit ist wohl nicht mglich, darum wir defaultmig Stck. bertragen. Anpassungen mssen vorgenommen werden.
				$articleData = array(
					"name" => $Artikelbeschreibung,
					"ordernumber" => $article->ArtikelnummerWebshop,
					"supplier" => " ",
					"description" => $Anmerkungen,
					"description_long" => $Anmerkungen,
					"taxID" => $article->MwStCode,
					"unitID" => 9,
					"active" => 0,
					"weight" => $article->Gewicht
				);
				
				// Mehrwertsteuer berprfen
				$mwst_id = getTaxID($article->MwStValue);
				if ($mwst_id)
				{
					$articleData["taxID"] = $mwst_id;
				}				
				
				//Artikel anlegen
				try
				{
					$articleResult = $import->sArticle($articleData);
				}
				catch(Exception $e)
				{
					echo $e->getMessage();
				}
				$preis  = 0.0;
				
				if($article->ArtikelpreisNetto != 'DSC_IGNORE')
				{
					//$mwst =  $article->MwStValue + 100;
					//$preis = str_replace(',','.',$article->ArtikelpreisNetto / 100) * $mwst;
					$preis = str_replace(',','.',$article->ArtikelpreisNetto);
				}
				else {
					$preis = str_replace(',','.',$article->ArtikelpreisBrutto);
				}
				
				$price = array("ordernumber" => $article->ArtikelnummerWebshop, "price" => $preis, "pricegroup" => "EK");
				
				//Artikelpreis gespeichert
				$import->sArticlePrice($price);
				
				if(!empty($article->Artikelkategorie) && $article->Artikelkategorie != 'DSC_IGNORE')
				{
					$export = &$api->export->shopware;
					
					$categoryFound = false;
					
					foreach ($export->sCategories() as $category) {
						if($category["description"] == $article->Artikelkategorie)
						{
							$import->sArticleCategories($articleResult["articleID"],array($category["categoryID"]));
							$categoryFound = true;
							break;
						}
					}
					
					if(!$categoryFound)
					{
						$catID = $import->sCategory(array("description" => $article->Artikelkategorie));
						
						$import->sArticleCategories($articleResult["articleID"],array($catID));
					}
				}
				$amount_successfully_created++;
			}
			unset($export);
			unset($import);
			
			WriteXMLResult($amount_articles, $amount_successfully_created);
		}
		else
		{
			WriteXMLResult(0, 0);
		}
	}
	catch(Exception $e)
	{
		print_r($e->getMessage());
		//WriteXMLResult(0, 0);
	}
 
	 
}

function setze_lagerbestand_im_shop()
{
	 require_once('../api/api.php');
     $amount_articles = 0;
	 $amount_successfully_created = 0;
	 try
	 {
	    $api = new sAPI();
		 
		$import = &$api->import->shopware;
		$stockValueFile = file_get_contents('php://input');
		if($stockValueFile != null && strlen($stockValueFile) > 0)
		{
			$articles = simplexml_load_string(($stockValueFile));
				
			$amount_successfully_created = 0;
			$amount_articles = count($articles);
			
			foreach($articles as $article)
			{
				$articleStock = array("ordernumber" => $article->ArtikelnummerWebshop, "instock" => $article->LagerBestandAktuell, 
									  "stockmin" => $article->LagerMindestBestand, "shippingtime" => $article->LagerWiederbeschaffungsdauer);
				
				$result = $import->sArticleStock($articleStock);
				if($result)
				{
					$amount_successfully_created++;
				}
			}
			unset($import);
			WriteXMLResult($amount_articles, $amount_successfully_created);
		}
		else
		{
			WriteXMLResult(0, 0);		
		}
	 }
	 catch(Exception $e)
	 {
	 	WriteXMLResult($amount_articles, $amount_successfully_created);
	 }
}

function hole_Artikelliste_fuer_export()
{
	 /** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="UTF-8";

	$domArticleList = $dom->appendChild($dom->createElement('ArtikelListeWebshop'));
	/*
     Klassen laden, Aliase erstellen und Einstellungen vornehmen
    */
    require_once('../api/api.php');
    $api = new sAPI();

    try
    {
    	$export =& $api->export->shopware;
    	
    	$articles = $export->sArticles();

		$amount_articles = count($articles);

		foreach($articles as $article)
		{
			 $domArticle = $domArticleList->appendChild($dom->createElement('row'));
			 $articleName = html_entity_decode(htmlentities($article['name'], ENT_QUOTES), ENT_QUOTES, 'UTF-8');
			 Add_NewDocElement($dom, $domArticle, 'ArtikelnummerWebshop', $article['ordernumber']);
			 Add_NewDocElement($dom, $domArticle, 'Artikelbeschreibung', $articleName);
		}
		unset($export);	
		$dom->formatOutput = true;
	
		//XML zurck geben
		echo $dom->saveXML();
		
		unset($dom);
	}
	catch(Exception $e)
	{
		//echo $e->getMessage();	
	}
}

function pruefeOffeneBestellungenImShop()
{
		require_once('../api/api.php');
		try
		{
			$api = new sAPI();

			$export =& $api->export->shopware;
			$orders = $export->sGetOrders(array("where"=>"status=".$GLOBALS["DEFAULT_ORDERS_STATUS"]));
			
			$amount_orders = count($orders);
			
			if($amount_orders > 0 && $orders)
			{
				echo 1;
			}
			else
			{
				echo 0;
			}
		}
		catch(Exception $e)
		{
			echo -1;
		}
}

function setze_Artikelpreise_im_shop()
{
	require_once('../api/api.php');
	$articleFile = file_get_contents('php://input');
	$amount_successfully_created = 0;
	$amount_articles = 0;
	try
	{
		if($articleFile != null && strlen($articleFile) > 0) {
				
			$articles = simplexml_load_string(($articleFile));

			$amount_articles = count($articles);
			
			$api = new sAPI();
			 
			$import = &$api->import->shopware;
			
			foreach($articles as $article)
			{
				$price = 0.0;
				if($article->ArtikelpreisNetto != 'DSC_IGNORE')
				{
					$price = $article->ArtikelpreisNetto;
				}
				else
				{
					$price = $article->ArtikelpreisBrutto;
				}
				$price = array("ordernumber" => $article->ArtikelnummerWebshop, "price" =>$price, "from" => $article->ArtikelPreisBeziehtSichAufMenge);
				
				$result = $import->sArticlePrice($price);
				
				if($result)
				{
					$amount_successfully_created++;
				}
			}
			WriteXMLResult($amount_articles, $amount_successfully_created);
		}
		else
		{
			WriteXMLResult(0,0);
		}
	}
	catch(Exception $e)
	{
		WriteXMLResult($amount_articles,$amount_successfully_created);
	}
}

function status_aendern($orderIdChange) {
    try {
            /*
                Klassen laden, Aliase erstellen und Einstellungen vornehmen
            */

            require_once('../api/api.php');
            $api = new sAPI();

            $export =& $api->export->shopware;
            /*
             * Bestellstatus anpassen
             * Mgliche Stati:
             * Texte: 'Offen','In Bearbeitung', 'Komplett abgeschlossen'
             * Werte: '0',    '1',              '2'
             *
            */

            $ShopStatus = $GLOBALS["aendern_zu"];
            //echo("Entry status_aendern = $ShopStatus \n"); -> immer 17 s. config.php
            switch($ShopStatus){
                case 0:
                    $ret = $export->sUpdateOrderStatus(array("orderIDs"=>array($orderIdChange), "status"=>0, "comment"=>"Wurde abgeholt!"));
                    break;
                case 1:
                    $ret = $export->sUpdateOrderStatus(array("orderIDs"=>array($orderIdChange), "status"=>1, "comment"=>"Wurde abgeholt!"));
                    break;
                case 2:
                    $ret = $export->sUpdateOrderStatus(array("orderIDs"=>array($orderIdChange), "status"=>2, "comment"=>"Wurde abgeholt!"));
                    break;
            }


        } catch (Exception $e) {

            $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
            '<orgamax_phperror>'."\n".
            '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
            '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
            '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
            '<line>'.utf8_encode(__LINE__).'</line>'."\n".
            '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
            '</orgamax_phperror>';
            die ($catchExeption);
        }
}


?>