<?php
/***************************************************************************\
*
*	Copyright (c) 2013 deltra Business Software GmbH & Co. KG
*	http://www.deltra.de
*	Zuletzt bearbeitet am: 2013-04-15
*
\***************************************************************************/

// Versionsnummer der Anbindung
$GLOBALS["VERSION"] = "4.0.00";

function db_prefix_aus_config_holen()
{
	$dir = dirname(__FILE__);
	if (!file_exists($dir.ORGAMAX_VIRTUEMART_CONFIG))
	{
		die(DeltraResources::getText(SHOPSYSTEM_CONFIG_NOT_FOUND));
	}
	
	require_once($dir.ORGAMAX_VIRTUEMART_CONFIG);
	
	//Config Objekt erzeugen. Dort werden von joomla alle Daten gespeichert
	$cfg = new JConfig();
	
	return $cfg->dbprefix;
}

function daten_holen()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$GLOBALS['datakind'] = '1';
	
	//VirtueMart verlangt als Orderstatus Buchstaben, also werden diese umgewandelt
	$orderStatus = '';
	switch($GLOBALS["DEFAULT_ORDERS_STATUS"]){
		case 1:
			$orderStatus = 'P';
			break;
		case 2:
			$orderStatus = 'C';
			break;
		case 3:
			$orderStatus = 'X';
			break;
		case 4:
			$orderStatus = 'R';
			break;
		case 5:
			$orderStatus = 'S';
			break;
	}
	
	$GLOBALS['query'] = 'SELECT
						'.$db_tableprefix.'vm_orders.order_id as orderID,
						'.$db_tableprefix.'vm_orders.order_id as BestellnummerShop,
						'.$db_tableprefix.'vm_orders.cdate as Bestelldatum,
						'.$db_tableprefix.'vm_orders.order_shipping_tax as FrachtkostenMwSt,
						'.$db_tableprefix.'vm_orders.order_discount as ZuschlagkostenBrutto1,
						'.$db_tableprefix.'vm_orders.ship_method_id as Lieferart,
						'.$db_tableprefix.'vm_orders.order_shipping as FrachtkostenNetto,
						'.$db_tableprefix.'vm_orders.customer_note as AnmerkungenBestellung,
						'.$db_tableprefix.'vm_orders.user_id as KundennummerWebshop,
						'.$db_tableprefix.'vm_order_user_info.company as Firmenname,
						'.$db_tableprefix.'vm_order_user_info.title as PersonAnrede,
						'.$db_tableprefix.'vm_order_user_info.last_name as PersonNachname,
						'.$db_tableprefix.'vm_order_user_info.first_name as PersonVorname,
						'.$db_tableprefix.'vm_order_user_info.address_1 as Strasse,
						'.$db_tableprefix.'vm_order_user_info.zip as Postleitzahl,
						'.$db_tableprefix.'vm_order_user_info.city as Ort,
						'.$db_tableprefix.'vm_order_user_info.country as Land,
						'.$db_tableprefix.'vm_order_user_info.user_email as Email,
						'.$db_tableprefix.'vm_order_user_info.phone_1 as Telefon,
						'.$db_tableprefix.'vm_order_user_info.fax as Fax,
						'.$db_tableprefix.'vm_order_user_info.extra_field_1 as ZusatzfeldKunde1,
						'.$db_tableprefix.'vm_order_user_info.extra_field_2 as ZusatzfeldKunde2,
						'.$db_tableprefix.'vm_order_user_info.extra_field_3 as ZusatzfeldKunde3,
						'.$db_tableprefix.'vm_order_user_info.extra_field_4 as ZusatzfeldKunde4,
						'.$db_tableprefix.'vm_order_user_info.extra_field_5 as ZusatzfeldKunde5,
						'.$db_tableprefix.'vm_order_user_info.bank_account_holder as BankkontoInhaber,
						'.$db_tableprefix.'vm_order_user_info.bank_account_nr as Bankkontonummer,
						'.$db_tableprefix.'vm_order_user_info.bank_sort_code as BankkontoBLZ,
						'.$db_tableprefix.'vm_order_user_info.bank_name as BankkontoBankName,
						'.$db_tableprefix.'vm_order_user_info.company as abweichendLieferungFirmenname,
						'.$db_tableprefix.'vm_order_user_info.last_name as abweichendLieferungPersNachname,
						'.$db_tableprefix.'vm_order_user_info.first_name as abweichendLieferungPersVorname,
						'.$db_tableprefix.'vm_order_user_info.address_1 as abweichendLieferungStrasse,
						'.$db_tableprefix.'vm_order_user_info.zip as abweichendLieferungPostleitzahl,
						'.$db_tableprefix.'vm_order_user_info.city as abweichendLieferungOrt,
						'.$db_tableprefix.'vm_order_user_info.country as abweichendLieferungLand,
						'.$db_tableprefix.'vm_order_user_info.title as abweichendLieferungPersAnrede,
						'.$db_tableprefix.'vm_order_user_info.company as abweichendRechnungFirmenname,
						'.$db_tableprefix.'vm_order_user_info.last_name as abweichendRechnungPersNachname,
						'.$db_tableprefix.'vm_order_user_info.first_name as abweichendRechnungPersVorname,
						'.$db_tableprefix.'vm_order_user_info.address_1 as abweichendRechnungStrasse,
						'.$db_tableprefix.'vm_order_user_info.zip as abweichendRechnungPostleitzahl,
						'.$db_tableprefix.'vm_order_user_info.city as abweichendRechnungOrt,
						'.$db_tableprefix.'vm_order_user_info.country as abweichendRechnungLand,
						'.$db_tableprefix.'vm_order_item.order_item_sku as ArtikelnummerShop,
						'.$db_tableprefix.'vm_order_item.product_quantity as Menge,
						'.$db_tableprefix.'vm_order_item.product_final_price as abweichenderEinzelpreisBrutto
						FROM '.$db_tableprefix.'vm_orders, '.$db_tableprefix.'vm_order_user_info, '.$db_tableprefix.'vm_order_item
						WHERE '.$db_tableprefix.'vm_orders.order_id = '.$db_tableprefix.'vm_order_user_info.order_id AND address_type=\'BT\'
						AND '.$db_tableprefix.'vm_order_item.order_id = '.$db_tableprefix.'vm_orders.order_id AND '.$db_tableprefix.'vm_orders.order_status = \''.$orderStatus.'\'
	';
	
	
	return $GLOBALS['datakind'];
}

function row_ueberpruefen($row)
{
	$db_tableprefix = db_prefix_aus_config_holen();
	
	# Anschrift �berarbeiten
	$row['AnmerkungenBestellung'] = htmlspecialchars($row['AnmerkungenBestellung']);
	
	//netto Zuschlagkosten hinzuf�gen
	if($row['ZuschlagkostenBrutto1'] < 0){
		$extraKosten = -$row['ZuschlagkostenBrutto1'];
		$row['ZuschlagkostenBrutto1'] = $extraKosten;	
	}
	else{
		$row['ZuschlagkostenBrutto1'] = '';
	}
	
	//Frachtkosten brutto ermitteln
	$row['FrachtkostenBrutto'] = $row['FrachtkostenNetto'] + $row['FrachtkostenMwSt'];
	$row['FrachtkostenBrutto'] = $row['FrachtkostenBrutto'];
	$row['FrachkostenNetto'] = '';
	$row['FrachkostenMwSt'] = '';
	
	//Bezahlart holen
	$query  = 'SELECT payment_method_code, payment_method_discount, payment_method_name';
	$query .= ' FROM '.$db_tableprefix.'vm_payment_method';
	$query .= ' WHERE payment_method_id IN( SELECT payment_method_id';
	$query .= ' FROM '.$db_tableprefix.'vm_order_payment';
	$query .= ' WHERE order_id = '.$row['orderID']. ')';
	
	$result = mysql_query($query);

    $row["Zahlungsart"] = "";
	if($result)
	{
		$data = mysql_fetch_assoc($result);
		if($data['payment_method_code'])
		{
            $zahlungsart = 'ORGAMAX_OS_ZAHLUNGSART_' . strtoupper($data["payment_method_code"]);
			if(DeltraResources::isResource($zahlungsart))
			{
				$row["Zahlungsart"] = DeltraResources::getText($zahlungsart);

				if(preg_match('/ORGAMAX_ZAHLUNGSART/',$row['Zahlungsart'])){
					$row['Zahlungsart'] = $data['payment_method_name'];
				}
			}
		}
		
	}
	
	//Lieferdaten holen
	// ST = SHIPPED TO BT = BILL TO
	$query  = 'SELECT last_name, first_name, title, phone_1, address_1, city, company, country, zip, user_email';
	$query .= ' FROM '.$db_tableprefix.'vm_order_user_info';
	$query .= " WHERE user_id = ".$row['KundennummerWebshop']. " AND order_id = ".$row['orderID']. " AND address_type='ST'";
	
	//Passt die Lieferdaten an.
	$result = mysql_query($query);
	if(mysql_num_rows($result) > 0){
		while($data = mysql_fetch_assoc($result)){
			$row['abweichendLieferungFirmenname'] = $data['company'];
			$row['abweichendLieferungPersNachname'] = $data['last_name'];
			$row['abweichendLieferungPersVorname'] = $data['first_name'];
			$row['abweichendLieferungStrasse'] = $data['address_1'];
			$row['abweichendLieferungPostleitzahl'] = $data['zip'];
			$row['abweichendLieferungOrt'] = $data['city'];
			$row['abweichendLieferungLand'] = $data['country'];
			$row['abweichendLieferungPersAnrede'] = $data['title'];
			$row['abweichendLieferungEmail'] = $data['user_email'];
		}
	}
	else {
		$row['abweichendLieferungFirmenname'] = $row['abweichendLieferungFirmenname'];
		$row['abweichendLieferungPersNachname'] = $row['abweichendLieferungPersNachname'];
		$row['abweichendLieferungPersVorname'] = $row['abweichendLieferungPersVorname'];
		$row['abweichendLieferungStrasse'] = $row['abweichendLieferungStrasse'];
		$row['abweichendLieferungOrt'] = $row['abweichendLieferungOrt'];
		$row['abweichendLieferungLand'] = $row['abweichendLieferungLand'];
		$row['abweichendLieferungPersAnrede'] = $row['abweichendLieferungPersAnrede'];
	}
	
	//Rechnungsdaten holen
	$query  = 'SELECT last_name, first_name, title, phone_1, address_1, city, company, country, zip, user_email';
	$query .= ' FROM '.$db_tableprefix.'vm_order_user_info';
	$query .= " WHERE user_id = ".$row['KundennummerWebshop']. " AND order_id = ".$row['orderID']. " AND address_type='BT'";
	
	$result = mysql_query($query);
	//Rechnungsdaten an die n?tigen Informationen �bergeben
	if(mysql_num_rows($result) > 0){
		while($data = mysql_fetch_assoc($result)){
			$row['abweichendRechnungFirmenname'] = $data['company'];
			$row['abweichendRechnungPersNachname'] = $data['last_name'];
			$row['abweichendRechnungPersVorname'] = $data['first_name'];
			$row['abweichendRechnungStrasse'] = $data['address_1'];
			$row['abweichendRechnungPostleitzahl'] = $data['zip'];
			$row['abweichendRechnungOrt'] = $data['city'];
			$row['abweichendRechnungLand'] = $data['country'];
			$row['abweichendRechnungPersAnrede'] = $data['title'];
			$row['abweichendRechnungEmail'] = $data['user_email'];
		}
	}
	else {
		$row['abweichendRechnungFirmenname'] = $row['abweichendRechnungFirmenname'];
		$row['abweichendRechnungPersNachname'] = $row['abweichendRechnungPersNachname'];
		$row['abweichendRechnungPersVorname'] = $row['abweichendRechnungPersVorname'];
		$row['abweichendRechnungStrasse'] = $row['abweichendRechnungStrasse'];
		$row['abweichendRechnungOrt'] = $row['abweichendRechnungOrt'];
		$row['abweichendRechnungLand'] = $row['abweichendRechnungLand'];
		$row['abweichendRechnungPersAnrede'] = $row['abweichendRechnungPersAnrede'];
	}
	
	//Wandelt den Timestamp in das Format dd.MM.YYYY um.
	$row['Bestelldatum'] = date('d.m.Y', $row['Bestelldatum']);
	
	
	//Steuern holen	
	$query = '
		SELECT tax_rate
		FROM '.$db_tableprefix.'vm_tax_rate
		WHERE tax_country = \''.$row['Land'].'\'
		AND vendor_id IN (
		   SELECT vendor_id
		   FROM '.$db_tableprefix.'vm_orders
		   WHERE order_id = '.$row['orderID'].'   
		)
		AND '.$db_tableprefix.'vm_tax_rate.tax_rate_id = (
		   SELECT product_tax_id
		   FROM '.$db_tableprefix.'vm_product
		   WHERE product_id = (
			  SELECT product_id
			  FROM '.$db_tableprefix.'vm_product
			  WHERE product_sku = \''.mysql_escape_string($row['ArtikelnummerShop']).'\'
		   )
		)';
	
	$result = mysql_query($query);

	if($result)
	{
		while($data = mysql_fetch_assoc($result))
		{
			// Mehrwertsteuer wird z.b mit 0.19000 ?bergeben. Deswegen wird dieser Wert in 19% umgewandelt
			$row['abweichendeMwStProzent'] = strval($data['tax_rate'] * 100);
		}
	}
	
	# Artikelnummer-Einstellungen:
	$row['Artikelnummer'] = ($GLOBALS['artno_handling'] == 1) ? $row['ArtikelnummerShop'] : '';
	
	//Kontrolliert den Titel. Beim Titel wird Herr und Frau so wie Dr. Prof. etc ?bergeben. 
	//Wird hier gefiltert
	if($row['PersonAnrede'] == 'Dr.' || $row['PersonAnrede'] == 'Prof.'){
		$row['PersonTitel'] = $row['PersonAnrede'];
		$row['PersonAnrede'] = '';
	}
	
	if($row['abweichendRechnungPersAnrede'] == 'Dr.' || $row['abweichendRechnungPersAnrede'] == 'Prof.') {
		$row['abweichendRechnungPersTitel'] = $row['abweichendRechnungPersAnrede'];
		$row['abweichendRechnungPersAnrede'] = '';
	}
	
	if($row['abweichendLieferungPersAnrede'] == 'Dr.' || $row['abweichendLieferungPersAnrede'] == 'Prof.') {
		$row['abweichendLieferungPersTitel'] = $row['abweichendLieferungPersAnrede'];
		$row['abweichendLieferungPersAnrede'] = '';
	}
	
	//L�nder korrigieren
	switch($row['Land']){
		case 'DEU':
			$row['Land'] = 'Deutschland';
			break;
		case 'AUT':
			$row['Land'] = '�sterreich';
			break;
		case 'CHE':
			$row['Land'] = 'Schweiz';
			break;
	}
	
	switch($row['abweichendLieferungLand']){
		case 'DEU':
			$row['abweichendLieferungLand'] = 'Deutschland';
			break;
		case 'AUT':
			$row['abweichendLieferungLand'] = '�sterreich';
			break;
		case 'CHE':
			$row['abweichendLieferungLand'] = 'Schweiz';
			break;
	}
	
	switch($row['abweichendRechnungLand']){
		case 'DEU':
			$row['abweichendRechnungLand'] = 'Deutschland';
			break;
		case 'AUT':
			$row['abweichendRechnungLand'] = '�sterreich';
			break;
		case 'CHE':
			$row['abweichendRechnungLand'] = 'Schweiz';
			break;
	}
	
	//Lieferart filtern
	$shipping_class = explode('|', $row['Lieferart']);
	$shipping = trim($shipping_class[1]);
	
	$shipping = strip_tags($shipping);
	$shipping = str_replace(' ','',$shipping);	
	$lieferart = '$row[\'Lieferart\'] = '.ORGAMAX_VM_LIEFERART_.strtoupper($shipping).';';	
	
	eval($lieferart);
	if(preg_match('/ORGAMAX_VM_/',$row['Lieferart'])){
		$row['Lieferart'] = $shipping_class[1];
	}
	return $row;
}

function artikeldaten_orgamax_zu_shop()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
			
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);
		
		foreach($articles as $article)
		{
			$articleNr = $article->ArtikelnummerWebshop;
			//Kontrolle ob der Artikel schon in der DB ist.
			$selectQuery = "SELECT product_id FROM ".$db_tableprefix."vm_product WHERE product_sku = '".$articleNr."'";
			$selectResult = mysql_query($selectQuery);
			
			$Artikelbeschreibung = $article->Artikelbeschreibung;
			# Sonderzeichen in Artikelbeschreibung umformatieren und String auf 64 Zeichen k�rzen
			# maximale L�nge f�r Feld 'product_name' in Datenbank von VirtueMart
			mb_internal_encoding("UTF-8");
			$Artikelbeschreibung = mb_substr($Artikelbeschreibung, 0, 64);
			$Anmerkungen = $article->Anmerkungen;

			
			$articleCurrency = "EUR";
			//Preise aktualisieren
			if($article->ArtikelpreisWaehrung == "\$")
			{
				$articleCurrency = "USD";
			}
			else if($article->ArtikelpreisWaehrung == "CH")
			{
				$articleCurrency = "CHF";
			}
			else if($article->ArtikelpreisWaehrung == "GBP")
			{
				$articleCurrency = "GBP";	
			}
			else
			{
				$articleCurrency = "EUR";	
			}
			
			//MwStCode ermitteln
			
			$tmpTaxRate = number_format(($article->MwStValue / 100),4);
			
			$mwstQuery = 'SELECT tax_rate_id FROM '.$db_tableprefix.'vm_tax_rate WHERE tax_rate = \''.$tmpTaxRate.'\'';
			
			$taxResult = mysql_query($mwstQuery);
			
			if(mysql_num_rows($taxResult) > 0){
				$article->MwStCode = mysql_result($taxResult,0);
			}
			
			
			$price = 0.0;
			
			if($article->ArtikelpreisNetto != 'DSC_IGNORE')
			{
				$price = str_replace(",",".", $article->ArtikelpreisNetto);
			}
			else
			{
				$tempValue = $article->ArtikelpreisBrutto;
				$price = str_replace(",",".", $tempValue);
			}

			if(mysql_num_rows($selectResult) > 0)
			{
				$product_id = mysql_result($selectResult,0);
		
				$updateMainQuery = "UPDATE ".$db_tableprefix."vm_product SET
									product_sku = '".$articleNr."',
									product_name = '".$Artikelbeschreibung."',
									product_s_desc = '".substr($Anmerkungen,0,254)."',
									product_desc = '".$Anmerkungen."',
									product_weight = '".$article->Gewicht."',
									product_unit = '".$article->Einheit."',
									product_tax_id = ".$article->MwStCode." WHERE product_id = ".$product_id;
				
				$updateResult = mysql_query($updateMainQuery);
				
				if(mysql_affected_rows() > 0)
				{
					$updatePrices = "UPDATE ".$db_tableprefix."vm_product_price(product_price, product_currency) SET
									 product_price = '".$price."', product_currency = '".$articleCurrency."' WHERE product_id = ".$product_id;
									 
					$updatePrice = mysql_query($updatePrices);
					
					if(mysql_affected_rows() > 0)
					{
						$amount_successfully_created++;
					}
				}
			}
			else {
				//Schreibe Artikelstammdaten
				//Shopper Group ID anpassen, wenn der Artikel in einer anderen Gruppe landen soll
				$mainQuery = "INSERT INTO ".$db_tableprefix."vm_product(vendor_id,product_sku, product_name,product_s_desc, product_desc, product_publish, product_weight,product_unit, product_tax_id, custom_attribute)
							  VALUES(
							  1,
							  '".$articleNr."',
							  '".$Artikelbeschreibung."',
							  '".substr($Anmerkungen,0,254)."',
							  '".$Anmerkungen."',
							  'N',
							  '".$article->Gewicht."',
							  '".$article->Einheit."',
							  ".$article->MwStCode.",
							  ''
							  )";
							  
				$mainResult = mysql_query($mainQuery);
				echo mysql_error();
				
				if(mysql_affected_rows() > 0)
				{
					$product_id = mysql_insert_id();
					
					//Preise anlegen
					$priceQuery = "INSERT INTO ".$db_tableprefix."vm_product_price(product_id,product_price, product_currency, shopper_group_id) VALUES(".$product_id.",'".$price."', '".$articleCurrency."',5)";
					
					$priceResult = mysql_query($priceQuery);
					
					if(mysql_affected_rows() > 0)
					{
						$amount_successfully_created++;
					}
				}
			}
			
		}
		WriteXMLResult($amount_articles, $amount_successfully_created);
	}
	else
	{
		WriteXMLResult(0, 0);		
	}
}

function setze_lagerbestand_im_shop()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
			
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);
		
		foreach($articles as $article)
		{
			$articleNr =  $article->ArtikelnummerWebshop;
			$selectQuery = "SELECT product_id FROM ".$db_tableprefix."vm_product WHERE product_sku = '".$articleNr."'";
			
			$query = mysql_query($selectQuery);
			
			if(mysql_num_rows($query) > 0)
			{
				$product_id = mysql_result($query, 0);
				$query = "UPDATE ".$db_tableprefix."vm_product SET product_in_stock = ".$article->LagerBestandAktuell." WHERE product_id =".$product_id;
				
				$result = mysql_query($query);
				
				
				if($result > 0)
				{
					$amount_successfully_created++;
				}
			}
		}
		WriteXMLResult($amount_articles, $amount_successfully_created);
	}
	else {
		WriteXMLResult(0, 0);
	}
}

function pruefeOffeneBestellungenImShop()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$orderStatus = '';
	switch($GLOBALS["DEFAULT_ORDERS_STATUS"]){
		case 1:
			$orderStatus = 'P';
			break;
		case 2:
			$orderStatus = 'C';
			break;
		case 3:
			$orderStatus = 'X';
			break;
		case 4:
			$orderStatus = 'R';
			break;
		case 5:
			$orderStatus = 'S';
			break;
	}
	
	$query = "SELECT count(order_id) FROM ".$db_tableprefix."vm_orders WHERE order_status = '".$orderStatus."'";
	
	$result = mysql_query(($query));
	
	if(mysql_num_rows($result) > 0)
	{
		$value = mysql_result($result, 0);
		
		if($value > 0)
		{
			echo 1;
		}
		else
		{
			echo 0;
		}
	}
	else
	{
		echo 0;		
	}
	
}

function hole_Artikelliste_fuer_export()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="utf-8";
	$domProducts = $dom->appendChild($dom->createElement('ArtikelListeWebshop'));
	if($GLOBALS['attributes_import'])
	{
		$query = "SELECT ".$db_tableprefix."vm_product_attribute.product_id, product_sku, product_name, attribute_value
				  FROM ".$db_tableprefix."vm_product,
					   ".$db_tableprefix."vm_product_attribute
				  WHERE ".$db_tableprefix."vm_product.product_id = ".$db_tableprefix."vm_product_attribute.product_id
				  ORDER BY ".$db_tableprefix."vm_product.product_sku";
	}
	else
	{
		$query = "SELECT product_sku, product_name
				  FROM ".$db_tableprefix."vm_product
				  WHERE product_parent_id = 0";
	}
	
	$result = mysql_query($query);
	
	if(mysql_num_rows($result) > 0)
	{
		$tempID = '';
		$artikelname = "";
		$artikelsku = "";
		while($articleRow = mysql_fetch_assoc($result))
		{
			if($GLOBALS['attributes_import'])
			{
				if($tempID == '')
				{
					$artikelsku = $articleRow["product_sku"];
					$artikelname = $articleRow["product_name"]. ' '. $articleRow['attribute_value'];
					$tempID = $articleRow["product_sku"];
				}
				else if($tempID == $articleRow["product_sku"])
				{
					$artikelname .= ' '.$articleRow["attribute_value"];
				}
				else
				{
					$tempID = $articleRow['product_sku'];
					
					$artikelRow = $domProducts->appendChild($dom->createElement('row'));
					Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $artikelsku);
					Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $artikelname);
					$artikelname = $articleRow['product_name']. ' '. $articleRow['attribute_value'];
					$artikelsku = $articleRow["product_sku"];
				}
			}
			else
			{
					$artikelRow = $domProducts->appendChild($dom->createElement('row'));
					Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $articleRow["product_sku"]);
					Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $articleRow["product_name"]);
			}
		}
		
		//Wenn Attribute geladen werden sollen, m?ssen die Hauptartikel nun nachgeladen werden
		if($GLOBALS['attributes_import'])
		{
			$query = "SELECT product_sku, product_name
				  FROM ".$db_tableprefix."vm_product
				  WHERE product_parent_id = 0";
				  
			$res = mysql_query($query);
			
			if(mysql_num_rows($res) > 0)
			{
				while($articleRow = mysql_fetch_assoc($res))
				{
					$artikelRow = $domProducts->appendChild($dom->createElement('row'));
					Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $articleRow["product_sku"]);
					Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $articleRow["product_name"]);
				}
			}
		}
	}
	$dom->formatOutput = true;
	//zur�ck geben
	echo $dom->saveXML();
}

function setze_Artikelpreise_im_shop()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
			
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);
		
		foreach($articles as $article)
		{
			$articleNr =  $article->ArtikelnummerWebshop;
			$query = "SELECT product_id
					  FROM ".$db_tableprefix."vm_product
					  WHERE product_sku = '".$articleNr."'";
			
			$result = mysql_query($query);
			
			if(mysql_num_rows($result) > 0)
			{
				$product_id = mysql_result($result, 0);
				
				$price = 0;
				
				if($article->ArtikelpreisNetto != 'DSC_IGNORE')
				{
					$price = str_replace(',','.',$article->ArtikelpreisNetto);
				}
				else 
				{
					$price = str_replace(',','.',$article->ArtikelpreisBrutto);
				}
				
				$updateQuery = "UPDATE ".$db_tableprefix."vm_product_price SET product_price = '".$price."' WHERE product_id = ".$product_id;
				
				$updateResult = mysql_query($updateQuery);
				
				if($updateResult > 0)
				{
					$amount_successfully_created++;
				}
			}		  
		}
		
		WriteXMLResult($amount_articles,$amount_successfully_created);
	}
	else
	{
		WriteXMLResult(0,0);
	}
}

function artikeldaten_shop_zu_orgamax()
{
	$db_tableprefix = db_prefix_aus_config_holen();
	$GLOBALS['datakind'] = "3";

	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="utf-8";
	 
	$domProducts = $dom->appendChild($dom->createElement('Artikelimport'));
	
	$query = "SELECT
				".$db_tableprefix."vm_product.product_id as shopid,
				".$db_tableprefix."vm_product.product_sku as ArtikelnummerWebshop, 
				".$db_tableprefix."vm_product.product_name as Artikelbeschreibung,
				".$db_tableprefix."vm_product.product_desc as Anmerkungen,
				".$db_tableprefix."vm_product.product_weight as Gewicht,
				".$db_tableprefix."vm_product.product_tax_id as MwStCode,
				".$db_tableprefix."vm_product.product_unit as Einheit,
				".$db_tableprefix."vm_product_price.product_price as ArtikelpreisNetto
			  FROM ".$db_tableprefix."vm_product,
				   ".$db_tableprefix."vm_product_price
			  WHERE
					".$db_tableprefix."vm_product.product_id = ".$db_tableprefix."vm_product_price.product_id
			  AND	".$db_tableprefix."vm_product.product_parent_id = 0
			  AND	".$db_tableprefix."vm_product_price.shopper_group_id = 5
			  ORDER BY ".$db_tableprefix."vm_product.product_sku
			  ";
	
	$result = mysql_query($query);
	
	if($result != null && mysql_num_rows($result) > 0)
	{
		while($article = mysql_fetch_assoc($result))
		{
			$articleNr =  $article['ArtikelnummerWebshop'];
			$articleBeschreibung =  $article['Artikelbeschreibung'];
			$articleEinheit = $article['Einheit'];
			$articleAnmerkungen = strip_tags($article['Anmerkungen']);
			//Steuern holen
			$taxQuery = "SELECT tax_rate FROM ".$db_tableprefix."vm_tax_rate WHERE tax_rate_id = ".$article['MwStCode']."";
			
			$taxRes = mysql_query($taxQuery);
			
			if(mysql_num_rows($taxRes) > 0)
			{
				$article['MwStCode'] = mysql_result($taxRes,0,0);
				$article['MwStCode'] = (int)number_format(($article['MwStCode']*100.00), 4);
			}
			else
			{
				$article['MwStCode'] = 0;
			}
			
			//VM Artikelkategorie abholen
			$catQuery = "SELECT category_name FROM ".$db_tableprefix."vm_category WHERE category_id = (SELECT category_id FROM ".$db_tableprefix."vm_product_category_xref WHERE product_id = ".$article['shopid']." LIMIT 0,1)";
			
			$catResult = mysql_query($catQuery);
			
			if(mysql_num_rows($catResult) > 0)
            {
				while($artCategory = mysql_fetch_assoc($catResult)) 
				{
					$article['Artikelkategorie'] = $artCategory['category_name'];
					break;
				}
			}
			else {
				$article['Artikelkategorie'] = '';
			}
			
			
			if($GLOBALS['attributes_import'])
			{
				$attribute_select = "SELECT
										 ".$db_tableprefix."vm_product.product_id as attid,
										 ".$db_tableprefix."vm_product.product_sku as ArtikelnummerWebshop,
										 ".$db_tableprefix."vm_product.product_weight as Gewicht,
										 ".$db_tableprefix."vm_product.product_unit as Einheit,
										 ".$db_tableprefix."vm_product_attribute.attribute_value as Var_Wert
									FROM
										 ".$db_tableprefix."vm_product,
										 ".$db_tableprefix."vm_product_attribute
									WHERE
										".$db_tableprefix."vm_product.product_parent_id = ".$article['shopid']." AND
										".$db_tableprefix."vm_product.product_id = ".$db_tableprefix."vm_product_attribute.product_id";
				
				$att_result = mysql_query($attribute_select);
				
				if($att_result != null && mysql_num_rows($att_result) > 0)
				{	
					$tempID = -1;
					$isVariationFound = false;
					$setVariation = false;
					
					// Sammelt die Attributwerte zusammen.
					//
					// Fall 1: Es gibt nur ein Attribut, das ggfs. noch weitere Attribute hat.
					// ==> Es wird ein Artikel f�r dieses Attribut zusammengestellt. Die Beschreibung
					//     allerdings setzt sich aus den Beschreibungen der Sub-Attribute zusammen.
					//
					// Fall 2: Es gibt mehrere Attribute
					// ==> Hier werden alle Attribute des Haupt-Artikels als jeweils eigener Artikel
					//     erfasst. Sollte eines der Attribute aber wieder Sub-Attribute haben, wird
					//     der erstellte Artikel um die Beschreibung der Sub-Attribute erweitert.
					while($attributeArticle = mysql_fetch_assoc($att_result))
					{
						// F�r den Fall, dass es Attribute zu dem Attribut gibt, Beschreibung erweitern:
						if ($tempID == $attributeArticle['attid'])
						{
							$articleDesc .= ' '.$attributeArticle['Var_Wert'];
							$setVariation = false;
						}
						// F�r den, dass es mehrere Attribute gibt, das aktuelle schonmal in einen Artikel binden:
						else if ($tempID != -1)
						{						
							$artikelRow = $domProducts->appendChild($dom->createElement('row'));
							Add_NewDocElement($dom, $artikelRow, 'Artikelnummer', '');
							Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $artikelnummer);
							Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $articleBeschreibung . " ".$articleDesc);
							Add_NewDocElement($dom, $artikelRow, 'MwStCode', ($article['MwStCode']));
							Add_NewDocElement($dom, $artikelRow, 'Einheit', $articleEinheit);
							Add_NewDocElement($dom, $artikelRow, 'Artikelkategorie', $article['Artikelkategorie']);
							Add_NewDocElement($dom, $artikelRow, 'Gewicht', $artikelGewicht);
							Add_NewDocElement($dom, $artikelRow, 'Volumen', '');
							Add_NewDocElement($dom, $artikelRow, 'Anmerkungen', $articleAnmerkungen);
							Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisNetto', $price);
							Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisBrutto', '');
							Add_NewDocElement($dom, $artikelRow, 'Einkaufspreis', '');
							Add_NewDocElement($dom, $artikelRow, 'Artikelbild','');
							Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld1', '');
							Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld2','');
							Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld3', '');
							Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld4','');
							Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld5', '');
							
							$setVariation = true;
						}
						else 
						{
							$setVariation = true;
						}
						
						if ($setVariation)
						{
							// Attribut-Daten zusammenschreiben					
							$isVariationFound = true;
							
							$articleDesc = '';
							$artikelnummer = '';
							$artikelGewicht = '';
							$artikelEinheit = '';
							$price = 0;
							$tempID = $attributeArticle['attid'];
							$price_select = "SELECT ".$db_tableprefix."vm_product_price.product_price
										FROM ".$db_tableprefix."vm_product_price
										WHERE product_id = ".$attributeArticle['attid'];
						
							$priceResult = mysql_query($price_select);
							
							$price = $article['ArtikelpreisNetto'];
							
							if(mysql_num_rows($priceResult) > 0)
							{
								$price = mysql_result($priceResult, 0);
							}
							$articleDesc = $attributeArticle['Var_Wert'];
							$artikelnummer = $attributeArticle['ArtikelnummerWebshop'];
							$artikelGewicht = $attributeArticle['Gewicht'];
							$artikelEinheit = $attributeArticle['Einheit'];		
						}
					}
					
					// Es wurde ein Attribut gefunden, welches aber noch nicht in einen Artikel gebunden wurde:					
					if ($isVariationFound)
					{
						$artikelRow = $domProducts->appendChild($dom->createElement('row'));
						Add_NewDocElement($dom, $artikelRow, 'Artikelnummer', '');
						Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $artikelnummer);
						Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $articleBeschreibung . " ".$articleDesc);
						Add_NewDocElement($dom, $artikelRow, 'MwStCode', ($article['MwStCode']));
						Add_NewDocElement($dom, $artikelRow, 'Einheit', $articleEinheit);
						Add_NewDocElement($dom, $artikelRow, 'Artikelkategorie', $article['Artikelkategorie']);
						Add_NewDocElement($dom, $artikelRow, 'Gewicht', $artikelGewicht);
						Add_NewDocElement($dom, $artikelRow, 'Volumen', '');
						Add_NewDocElement($dom, $artikelRow, 'Anmerkungen', $articleAnmerkungen);
						Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisNetto', $price);
						Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisBrutto', '');
						Add_NewDocElement($dom, $artikelRow, 'Einkaufspreis', '');
						Add_NewDocElement($dom, $artikelRow, 'Artikelbild','');
						Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld1', '');
						Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld2','');
						Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld3', '');
						Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld4','');
						Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld5', '');
					}
					
					
						
				}
			}
			
			$artikelRow = $domProducts->appendChild($dom->createElement('row'));
			
			Add_NewDocElement($dom, $artikelRow, 'Artikelnummer', '');
			Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $articleNr);
			Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $articleBeschreibung);
			Add_NewDocElement($dom, $artikelRow, 'MwStCode', ($article['MwStCode']));
			Add_NewDocElement($dom, $artikelRow, 'Einheit', $articleEinheit);
			Add_NewDocElement($dom, $artikelRow, 'Artikelkategorie', $article['Artikelkategorie']);
			Add_NewDocElement($dom, $artikelRow, 'Gewicht', $article['Gewicht']);
			Add_NewDocElement($dom, $artikelRow, 'Volumen', '');
			Add_NewDocElement($dom, $artikelRow, 'Anmerkungen', $articleAnmerkungen);
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisNetto', $article['ArtikelpreisNetto']);
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisBrutto', '');
			Add_NewDocElement($dom, $artikelRow, 'Einkaufspreis', '');
			Add_NewDocElement($dom, $artikelRow, 'Artikelbild','');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld1', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld2','');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld3', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld4','');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld5', '');
		}
		
	}
	$dom->formatOutput = true;
    $GLOBALS['XMLDoc'] = $dom->saveXML();
	return $GLOBALS['datakind'];
	
}// artikeldaten_shop_zu_orgamax

function artRow_ueberpruefen($artRow)
{	
	return $artRow;
}// article_row_ueberpruefen

function status_aendern($orderId) {
	$db_tableprefix = db_prefix_aus_config_holen();
	$ShopStatus = $GLOBALS["aendern_zu"];
	
	switch($ShopStatus){
		case 1:
			$ShopStatus = 'P';
			break;
		case 2:
			$ShopStatus = 'C';
			break;
		case 3:
			$ShopStatus = 'X';
			break;
		case 4:
			$ShopStatus = 'R';
			break;
		case 5:
			$ShopStatus = 'S';
			break;
	}
	$query  = 'SELECT order_status';
	$query .= ' FROM '.$db_tableprefix.'vm_orders';
	$query .= ' WHERE order_id = '.$orderId;
	
	$data = mysql_query($query);
	if($data) {
		$erg = mysql_fetch_assoc($data);
		
		// Order_status vergleichen
		if($erg['order_status'] !=  'S'){
			// Update Befehl vorbereiten
			$query = 'UPDATE '.$db_tableprefix.'vm_orders SET order_status = \''.$ShopStatus.'\' WHERE order_id = '.$orderId;
			mysql_query($query);
				
			//Kontrolliert ob der Update Befehl geklappt hat
			$error = mysql_error();
				
			if($error == ''){
				$query = 'UPDATE '.$db_tableprefix.'vm_order_item SET order_status = \''.$ShopStatus.'\' WHERE order_id = '.$orderId;
				
				mysql_query($query);
				
				$error = mysql_error();
				
				if($error == ''){
					$query  = 'INSERT INTO '.$db_tableprefix.'vm_order_history(order_id,order_status_code,date_added,customer_notified)';
					$query .= ' VALUES('.$orderId.',\''.$ShopStatus.'\',\''.date('Y-m-d H:i:s').'\',1)';
					
					mysql_query($query);
					$error = mysql_error();
					if($error == ''){
						die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' wurde auf '" . $ShopStatus . "' gesetzt."));
					}
					else{
						die(xml_error_ausgeben("Bei der Fortschreibung der Shop History für die order_id: '$orderId' auf den Wert '$ShopStatus' trat ein Fehler auf. Das Query meldete MySql '. $error .'", __FILE__, __FUNCTION__, __LINE__));
					}
				}
				else{
					die(xml_error_ausgeben("Bei der Statusänderung der Bestellung '$orderId' auf den Wert '$ShopStatus' trat ein Fehler auf. Das Query meldete MySql '. $error .'", __FILE__, __FUNCTION__, __LINE__));
				}
			}
			else{
				die(xml_error_ausgeben("Bei der Statusänderung der Bestellung '$orderId' auf den Wert '$ShopStatus' trat ein Fehler auf. Das Query meldete MySql '. $error .'", __FILE__, __FUNCTION__, __LINE__));
			}
		}
	}
}

function starten()
{
	$dir = dirname(__FILE__);
	if(file_exists($dir.ORGAMAX_VIRTUEMART_CONFIG))
	{
		require_once($dir.ORGAMAX_VIRTUEMART_CONFIG);
		
		//Config Objekt erzeugen. Dort werden von joomla alle Daten gespeichert
		$config = new JConfig();
		
		//Verbinden mit der Datenbank und in der GLOBALS variable speichern
		$GLOBALS['sql_con'] = mysql_connect($config->host, $config->user, $config->password);
		//Die Datenbank von joomla ausw?hlen
		$data = mysql_select_db($config->db, $GLOBALS['sql_con']);
		
		//Wird die Datenbank nicht gefunden, so wird ein Fehler ausgegeben
		if(!$data){
			die (xml_error_ausgeben('Es wurde keine entsprechende Datenbank auf dem Server gefunden ',__FILE__, __FUNCTION__, __LINE__));
		}
		$charset = mysql_client_encoding($GLOBALS['sql_con']);
		
		if($charset != 'utf8')
		{
			mysql_set_charset('utf8', $GLOBALS['sql_con']);
		}
		
		//mysql_set_charset('utf8',$GLOBALS['sql_con']);
	}
	else{
		die (xml_error_ausgeben($GLOBALS['err_msg']['shop_cfg'],__FILE__, __FUNCTION__, __LINE__));
	}
}

function ende(){
	mysql_close($GLOBALS['sql_con']);
}
?>